<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::binary_search_tree_kernel_1&lt; domain, range, mem_manager, compare &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">binary_search_tree_kernel_1</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1binary__search__tree__kernel__1-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::binary_search_tree_kernel_1&lt; domain, range, mem_manager, compare &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::binary_search_tree_kernel_1&lt; domain, range, mem_manager, compare &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1binary__search__tree__kernel__1.png" usemap="#dlib::binary_5Fsearch_5Ftree_5Fkernel_5F1_3C_20domain_2C_20range_2C_20mem_5Fmanager_2C_20compare_20_3E_map" alt=""/>
  <map id="dlib::binary_5Fsearch_5Ftree_5Fkernel_5F1_3C_20domain_2C_20range_2C_20mem_5Fmanager_2C_20compare_20_3E_map" name="dlib::binary_5Fsearch_5Ftree_5Fkernel_5F1_3C_20domain_2C_20range_2C_20mem_5Fmanager_2C_20compare_20_3E_map">
<area href="classdlib_1_1enumerable.html" alt="dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;" shape="rect" coords="0,56,459,80"/>
<area href="classdlib_1_1asc__pair__remover.html" alt="dlib::asc_pair_remover&lt; domain, range, compare &gt;" shape="rect" coords="469,56,928,80"/>
<area href="classdlib_1_1pair__remover.html" alt="dlib::pair_remover&lt; domain, range &gt;" shape="rect" coords="469,0,928,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1mpair.html">mpair</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:aa725ba4f72e696a5031ea41d8db4baa1"><td class="memItemLeft" align="right" valign="top"><a id="aa725ba4f72e696a5031ea41d8db4baa1"></a>
typedef domain&#160;</td><td class="memItemRight" valign="bottom"><b>domain_type</b></td></tr>
<tr class="separator:aa725ba4f72e696a5031ea41d8db4baa1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a98c1e9cb53c8775a0f21e58d3484beac"><td class="memItemLeft" align="right" valign="top"><a id="a98c1e9cb53c8775a0f21e58d3484beac"></a>
typedef range&#160;</td><td class="memItemRight" valign="bottom"><b>range_type</b></td></tr>
<tr class="separator:a98c1e9cb53c8775a0f21e58d3484beac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a638d6e8ad0d241c00588036036c9e77c"><td class="memItemLeft" align="right" valign="top"><a id="a638d6e8ad0d241c00588036036c9e77c"></a>
typedef compare&#160;</td><td class="memItemRight" valign="bottom"><b>compare_type</b></td></tr>
<tr class="separator:a638d6e8ad0d241c00588036036c9e77c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab215143c44e9d5086f0f5ad2d127bde8"><td class="memItemLeft" align="right" valign="top"><a id="ab215143c44e9d5086f0f5ad2d127bde8"></a>
typedef mem_manager&#160;</td><td class="memItemRight" valign="bottom"><b>mem_manager_type</b></td></tr>
<tr class="separator:ab215143c44e9d5086f0f5ad2d127bde8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a></td></tr>
<tr class="memitem:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#aece453aca3947d8b1f7bf016d5f99cda">type</a></td></tr>
<tr class="separator:aece453aca3947d8b1f7bf016d5f99cda inherit pub_types_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1asc__pair__remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1asc__pair__remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1asc__pair__remover.html">dlib::asc_pair_remover&lt; domain, range, compare &gt;</a></td></tr>
<tr class="memitem:a49ce4da1dbccc4a6ace9bec30664610c inherit pub_types_classdlib_1_1asc__pair__remover"><td class="memItemLeft" align="right" valign="top">typedef compare&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1asc__pair__remover.html#a49ce4da1dbccc4a6ace9bec30664610c">compare_type</a></td></tr>
<tr class="separator:a49ce4da1dbccc4a6ace9bec30664610c inherit pub_types_classdlib_1_1asc__pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classdlib_1_1pair__remover"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classdlib_1_1pair__remover')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover&lt; domain, range &gt;</a></td></tr>
<tr class="memitem:ae77d4c0fb6e38060543ef5323dfeeccc inherit pub_types_classdlib_1_1pair__remover"><td class="memItemLeft" align="right" valign="top">typedef domain&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#ae77d4c0fb6e38060543ef5323dfeeccc">domain_type</a></td></tr>
<tr class="separator:ae77d4c0fb6e38060543ef5323dfeeccc inherit pub_types_classdlib_1_1pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7250053c066db818a5f0c0a886f25a20 inherit pub_types_classdlib_1_1pair__remover"><td class="memItemLeft" align="right" valign="top"><a id="a7250053c066db818a5f0c0a886f25a20"></a>
typedef range&#160;</td><td class="memItemRight" valign="bottom"><b>range_type</b></td></tr>
<tr class="separator:a7250053c066db818a5f0c0a886f25a20 inherit pub_types_classdlib_1_1pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a567289967b081d2915e7e0bef6a5cd45"><td class="memItemLeft" align="right" valign="top"><a id="a567289967b081d2915e7e0bef6a5cd45"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>clear</b> ()</td></tr>
<tr class="separator:a567289967b081d2915e7e0bef6a5cd45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56d311f09218e1bb1b7472d72f7b2a92"><td class="memItemLeft" align="right" valign="top"><a id="a56d311f09218e1bb1b7472d72f7b2a92"></a>
short&#160;</td><td class="memItemRight" valign="bottom"><b>height</b> () const</td></tr>
<tr class="separator:a56d311f09218e1bb1b7472d72f7b2a92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ffbcc5fa469c414509b0d49eb50d970"><td class="memItemLeft" align="right" valign="top"><a id="a4ffbcc5fa469c414509b0d49eb50d970"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>count</b> (const domain &amp;item) const</td></tr>
<tr class="separator:a4ffbcc5fa469c414509b0d49eb50d970"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7745c4017a63e514eb6bf750f988a8e"><td class="memItemLeft" align="right" valign="top"><a id="af7745c4017a63e514eb6bf750f988a8e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>add</b> (domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:af7745c4017a63e514eb6bf750f988a8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a02e8e9b539d6c63a0905d52f6e38df"><td class="memItemLeft" align="right" valign="top"><a id="a7a02e8e9b539d6c63a0905d52f6e38df"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>remove</b> (const domain &amp;d, domain &amp;d_copy, range &amp;r)</td></tr>
<tr class="separator:a7a02e8e9b539d6c63a0905d52f6e38df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af75d40b5b9c5b35940ddf616b41e0373"><td class="memItemLeft" align="right" valign="top"><a id="af75d40b5b9c5b35940ddf616b41e0373"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>destroy</b> (const domain &amp;item)</td></tr>
<tr class="separator:af75d40b5b9c5b35940ddf616b41e0373"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86ad31be63136f48c788943d40a9cdc2"><td class="memItemLeft" align="right" valign="top"><a id="a86ad31be63136f48c788943d40a9cdc2"></a>
const range *&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (const domain &amp;item) const</td></tr>
<tr class="separator:a86ad31be63136f48c788943d40a9cdc2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6aed440ed4138f6b6b0b332f69c35c7a"><td class="memItemLeft" align="right" valign="top"><a id="a6aed440ed4138f6b6b0b332f69c35c7a"></a>
range *&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (const domain &amp;item)</td></tr>
<tr class="separator:a6aed440ed4138f6b6b0b332f69c35c7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2bb6b50d78b3b571536befa6d8d073eb"><td class="memItemLeft" align="right" valign="top"><a id="a2bb6b50d78b3b571536befa6d8d073eb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">binary_search_tree_kernel_1</a> &amp;item)</td></tr>
<tr class="separator:a2bb6b50d78b3b571536befa6d8d073eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a97284253c0e7b4c9e2b4a715e6497f74"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a97284253c0e7b4c9e2b4a715e6497f74">remove_any</a> (domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:a97284253c0e7b4c9e2b4a715e6497f74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1ea985c164591279a5d82b822dfdc3f"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#ab1ea985c164591279a5d82b822dfdc3f">size</a> () const</td></tr>
<tr class="separator:ab1ea985c164591279a5d82b822dfdc3f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8c4b493e0d113931dfe307259cc85f6"><td class="memItemLeft" align="right" valign="top"><a id="ac8c4b493e0d113931dfe307259cc85f6"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start</b> () const</td></tr>
<tr class="separator:ac8c4b493e0d113931dfe307259cc85f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a50dc035a8ef7a68435d13056aa2eb050"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a50dc035a8ef7a68435d13056aa2eb050">reset</a> () const</td></tr>
<tr class="separator:a50dc035a8ef7a68435d13056aa2eb050"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1121b6232111ce3fb767ce54f46f7f95"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a1121b6232111ce3fb767ce54f46f7f95">current_element_valid</a> () const</td></tr>
<tr class="separator:a1121b6232111ce3fb767ce54f46f7f95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac28214173708fd4d2580c0ce1eb79eb3"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#ac28214173708fd4d2580c0ce1eb79eb3">element</a> () const</td></tr>
<tr class="separator:ac28214173708fd4d2580c0ce1eb79eb3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac2c93b1efbc2c3c0b94ae2ba9662a0e0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#ac2c93b1efbc2c3c0b94ae2ba9662a0e0">element</a> ()</td></tr>
<tr class="separator:ac2c93b1efbc2c3c0b94ae2ba9662a0e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f0697302d80d64b871d2851e0e1f7ab"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a2f0697302d80d64b871d2851e0e1f7ab">move_next</a> () const</td></tr>
<tr class="separator:a2f0697302d80d64b871d2851e0e1f7ab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a500d418db6dbe762f1a323ff333fff44"><td class="memItemLeft" align="right" valign="top"><a id="a500d418db6dbe762f1a323ff333fff44"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>remove_last_in_order</b> (domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:a500d418db6dbe762f1a323ff333fff44"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a846e877b70d3938625bdbaabf048c2fb"><td class="memItemLeft" align="right" valign="top"><a id="a846e877b70d3938625bdbaabf048c2fb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>remove_current_element</b> (domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:a846e877b70d3938625bdbaabf048c2fb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2293eda458495b17a06b9a186f1feae"><td class="memItemLeft" align="right" valign="top"><a id="ab2293eda458495b17a06b9a186f1feae"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>position_enumerator</b> (const domain &amp;d) const</td></tr>
<tr class="separator:ab2293eda458495b17a06b9a186f1feae"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a02f372daafb83c1f8a3c224c55a49955"><td class="memItemLeft" align="right" valign="top"><a id="a02f372daafb83c1f8a3c224c55a49955"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>rotate_left</b> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t)</td></tr>
<tr class="separator:a02f372daafb83c1f8a3c224c55a49955"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aadf3f5652822a89427cf79ce3de8fd07"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#aadf3f5652822a89427cf79ce3de8fd07">rotate_right</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t)</td></tr>
<tr class="separator:aadf3f5652822a89427cf79ce3de8fd07"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3bd8375d36690c73cd43bac5bad54116"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a3bd8375d36690c73cd43bac5bad54116">double_rotate_right</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t)</td></tr>
<tr class="separator:a3bd8375d36690c73cd43bac5bad54116"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a734371ae8e0606d7d341da091d8ba601"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a734371ae8e0606d7d341da091d8ba601">double_rotate_left</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t)</td></tr>
<tr class="separator:a734371ae8e0606d7d341da091d8ba601"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77eaa41d98b18d23f821c8efe3c943e0"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a77eaa41d98b18d23f821c8efe3c943e0">remove_biggest_element_in_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t, domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:a77eaa41d98b18d23f821c8efe3c943e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a615d634af52cb9a8431e42d3b8900c45"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a615d634af52cb9a8431e42d3b8900c45">remove_least_element_in_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t, domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:a615d634af52cb9a8431e42d3b8900c45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff47d2bc4f55d080865fa15abb0b3e48"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#aff47d2bc4f55d080865fa15abb0b3e48">add_to_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t, domain &amp;d, range &amp;r)</td></tr>
<tr class="separator:aff47d2bc4f55d080865fa15abb0b3e48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2aaa57cc756c29b278da5177c0e19467"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a2aaa57cc756c29b278da5177c0e19467">remove_from_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t, const domain &amp;d, domain &amp;d_copy, range &amp;r)</td></tr>
<tr class="separator:a2aaa57cc756c29b278da5177c0e19467"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae337c557ee2655f08f140c551e0ba0be"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#ae337c557ee2655f08f140c551e0ba0be">remove_from_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t, const domain &amp;item)</td></tr>
<tr class="separator:ae337c557ee2655f08f140c551e0ba0be"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2891dc81fcc89aa3b639b770b012205f"><td class="memItemLeft" align="right" valign="top">const range *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a2891dc81fcc89aa3b639b770b012205f">return_reference</a> (const <a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *t, const domain &amp;d) const</td></tr>
<tr class="separator:a2891dc81fcc89aa3b639b770b012205f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adf495bcfa6815a018eb364366b71c032"><td class="memItemLeft" align="right" valign="top">range *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#adf495bcfa6815a018eb364366b71c032">return_reference</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *t, const domain &amp;d)</td></tr>
<tr class="separator:adf495bcfa6815a018eb364366b71c032"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55a09ae0307c71319e5952de10c0ab47"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a55a09ae0307c71319e5952de10c0ab47">keep_node_balanced</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t)</td></tr>
<tr class="separator:a55a09ae0307c71319e5952de10c0ab47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a833d5f1767dabc21cb6da8fe635f53ec"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a833d5f1767dabc21cb6da8fe635f53ec">get_count</a> (const domain &amp;item, <a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *tree_root) const</td></tr>
<tr class="separator:a833d5f1767dabc21cb6da8fe635f53ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a296ed73611e594d2b8399d58f75777d2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a296ed73611e594d2b8399d58f75777d2">delete_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *t)</td></tr>
<tr class="separator:a296ed73611e594d2b8399d58f75777d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4778a513f7c9dfa94621bbe8250cfa5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#ad4778a513f7c9dfa94621bbe8250cfa5">push</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *n) const</td></tr>
<tr class="separator:ad4778a513f7c9dfa94621bbe8250cfa5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83ac44b65c7ca10e0f33b58685a65a09"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a83ac44b65c7ca10e0f33b58685a65a09">pop</a> () const</td></tr>
<tr class="separator:a83ac44b65c7ca10e0f33b58685a65a09"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a686d52bcba67526bbc998165fe61f8e1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a686d52bcba67526bbc998165fe61f8e1">fix_stack</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *t, unsigned char depth=0)</td></tr>
<tr class="separator:a686d52bcba67526bbc998165fe61f8e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a15d9cab709e10e2e1ff726db254b1238"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a15d9cab709e10e2e1ff726db254b1238">remove_current_element_from_tree</a> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;t, domain &amp;d, range &amp;r, unsigned long cur_stack_pos=1)</td></tr>
<tr class="separator:a15d9cab709e10e2e1ff726db254b1238"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a50377c286cfe55bdfb53478de9a4a91c"><td class="memItemLeft" align="right" valign="top"><a id="a50377c286cfe55bdfb53478de9a4a91c"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>binary_search_tree_kernel_1</b> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">binary_search_tree_kernel_1</a> &amp;)</td></tr>
<tr class="separator:a50377c286cfe55bdfb53478de9a4a91c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae23e0934a66af1213973219be8cb0c26"><td class="memItemLeft" align="right" valign="top"><a id="ae23e0934a66af1213973219be8cb0c26"></a>
<a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">binary_search_tree_kernel_1</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (<a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">binary_search_tree_kernel_1</a> &amp;)</td></tr>
<tr class="separator:ae23e0934a66af1213973219be8cb0c26"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a39033b2632f7aace9b0db6ac934d72ed"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1mpair.html">mpair</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a39033b2632f7aace9b0db6ac934d72ed">p</a></td></tr>
<tr class="separator:a39033b2632f7aace9b0db6ac934d72ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa40d070c812ba72ee35f9e959efc5a4f"><td class="memItemLeft" align="right" valign="top"><a id="aa40d070c812ba72ee35f9e959efc5a4f"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>tree_size</b></td></tr>
<tr class="separator:aa40d070c812ba72ee35f9e959efc5a4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37ab54abff33d8f198d07140b065f4bb"><td class="memItemLeft" align="right" valign="top"><a id="a37ab54abff33d8f198d07140b065f4bb"></a>
<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>tree_root</b></td></tr>
<tr class="separator:a37ab54abff33d8f198d07140b065f4bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa25662e757dab44450a2552e1207fce5"><td class="memItemLeft" align="right" valign="top"><a id="aa25662e757dab44450a2552e1207fce5"></a>
<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>current_element</b></td></tr>
<tr class="separator:aa25662e757dab44450a2552e1207fce5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca6df6d205f1cc1c400f5dee9cce47bc"><td class="memItemLeft" align="right" valign="top"><a id="aca6df6d205f1cc1c400f5dee9cce47bc"></a>
mem_manager::template rebind&lt; <a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> &gt;::other&#160;</td><td class="memItemRight" valign="bottom"><b>pool</b></td></tr>
<tr class="separator:aca6df6d205f1cc1c400f5dee9cce47bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd155835c414d28e50f4581c446b3fce"><td class="memItemLeft" align="right" valign="top"><a id="afd155835c414d28e50f4581c446b3fce"></a>
mem_manager::template rebind&lt; <a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> * &gt;::other&#160;</td><td class="memItemRight" valign="bottom"><b>ppool</b></td></tr>
<tr class="separator:afd155835c414d28e50f4581c446b3fce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac5c525fb889e87360a69c0d2fcf2f8fa"><td class="memItemLeft" align="right" valign="top"><a id="ac5c525fb889e87360a69c0d2fcf2f8fa"></a>
short&#160;</td><td class="memItemRight" valign="bottom"><b>tree_height</b></td></tr>
<tr class="separator:ac5c525fb889e87360a69c0d2fcf2f8fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa582b0edf9641ed65d20ae2a25b20d74"><td class="memItemLeft" align="right" valign="top"><a id="aa582b0edf9641ed65d20ae2a25b20d74"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>at_start_</b></td></tr>
<tr class="separator:aa582b0edf9641ed65d20ae2a25b20d74"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64221f3b1a056aa78772a22541cd3012"><td class="memItemLeft" align="right" valign="top"><a id="a64221f3b1a056aa78772a22541cd3012"></a>
unsigned char&#160;</td><td class="memItemRight" valign="bottom"><b>stack_pos</b></td></tr>
<tr class="separator:a64221f3b1a056aa78772a22541cd3012"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af96311861876f749147b0de53c61dc5c"><td class="memItemLeft" align="right" valign="top"><a id="af96311861876f749147b0de53c61dc5c"></a>
<a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> **&#160;</td><td class="memItemRight" valign="bottom"><b>stack</b></td></tr>
<tr class="separator:af96311861876f749147b0de53c61dc5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9304bef4caab8da5799b906045e32b5d"><td class="memItemLeft" align="right" valign="top"><a id="a9304bef4caab8da5799b906045e32b5d"></a>
compare&#160;</td><td class="memItemRight" valign="bottom"><b>comp</b></td></tr>
<tr class="separator:a9304bef4caab8da5799b906045e32b5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1enumerable"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1enumerable')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1enumerable.html">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a></td></tr>
<tr class="memitem:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1enumerable.html#a328c55c7c5df14e115cd502e9756e8a3">operator=</a> (const <a class="el" href="classdlib_1_1enumerable.html">enumerable</a> &amp;)</td></tr>
<tr class="separator:a328c55c7c5df14e115cd502e9756e8a3 inherit pro_methods_classdlib_1_1enumerable"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1asc__pair__remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1asc__pair__remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1asc__pair__remover.html">dlib::asc_pair_remover&lt; domain, range, compare &gt;</a></td></tr>
<tr class="memitem:aee6bd5db7e422848db011651dd50b71d inherit pro_methods_classdlib_1_1asc__pair__remover"><td class="memItemLeft" align="right" valign="top"><a id="aee6bd5db7e422848db011651dd50b71d"></a>
<a class="el" href="classdlib_1_1asc__pair__remover.html">asc_pair_remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1asc__pair__remover.html">asc_pair_remover</a> &amp;)</td></tr>
<tr class="separator:aee6bd5db7e422848db011651dd50b71d inherit pro_methods_classdlib_1_1asc__pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classdlib_1_1pair__remover"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classdlib_1_1pair__remover')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover&lt; domain, range &gt;</a></td></tr>
<tr class="memitem:aead61aff1af3e012c691953da8020750 inherit pro_methods_classdlib_1_1pair__remover"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#aead61aff1af3e012c691953da8020750">operator=</a> (const <a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a> &amp;)</td></tr>
<tr class="separator:aead61aff1af3e012c691953da8020750 inherit pro_methods_classdlib_1_1pair__remover"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aff47d2bc4f55d080865fa15abb0b3e48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff47d2bc4f55d080865fa15abb0b3e48">&#9670;&nbsp;</a></span>add_to_tree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::add_to_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t != 0  (i.e. there must be something in the tree to remove) 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - the least node in t has been removed 
    - the least node domain element in t has been put into #d 
    - the least node range element in t has been put into #r
    - #t is still a binary search tree 
    - returns false if the height of the tree has not changed 
    - returns true if the height of the tree has shrunk by one
</pre><p> ! </p>

</div>
</div>
<a id="a1121b6232111ce3fb767ce54f46f7f95"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1121b6232111ce3fb767ce54f46f7f95">&#9670;&nbsp;</a></span>current_element_valid()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::current_element_valid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - #current_element_valid() == false 
    - #at_start() == true
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1d8826bb2077f454da01103773f892c6">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a296ed73611e594d2b8399d58f75777d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a296ed73611e594d2b8399d58f75777d2">&#9670;&nbsp;</a></span>delete_tree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::delete_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - tree_root == the root of a binary search tree or 0
ensures
    - if (tree_root == 0) then
        - returns 0
    - else
        - returns the number of elements in tree_root that are 
          equivalent to item
</pre><p> ! </p>

</div>
</div>
<a id="a734371ae8e0606d7d341da091d8ba601"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a734371ae8e0606d7d341da091d8ba601">&#9670;&nbsp;</a></span>double_rotate_left()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::double_rotate_left </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t-&gt;balance == -2 
    - t-&gt;left-&gt;balance == 1 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - #t is still a binary search tree 
    - #t now has a balance of 0 
    - #t now has a height smaller by 1             
</pre><p> ! </p>

</div>
</div>
<a id="a3bd8375d36690c73cd43bac5bad54116"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3bd8375d36690c73cd43bac5bad54116">&#9670;&nbsp;</a></span>double_rotate_right()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::double_rotate_right </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t-&gt;balance == -2 
    - t-&gt;left-&gt;balance == 0 or -1 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - #t is still a binary search tree 
    - #t-&gt;balance is between 1 and -1 
    - #t now has a height smaller by 1 if #t-&gt;balance == 0
</pre><p>! </p>

</div>
</div>
<a id="ac2c93b1efbc2c3c0b94ae2ba9662a0e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac2c93b1efbc2c3c0b94ae2ba9662a0e0">&#9670;&nbsp;</a></span>element() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp; <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a43a289e594edbf10a8300f5b49569524">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="ac28214173708fd4d2580c0ce1eb79eb3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac28214173708fd4d2580c0ce1eb79eb3">&#9670;&nbsp;</a></span>element() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classdlib_1_1map__pair.html">map_pair</a>&lt; domain, range &gt; &amp; <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::element </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if we are currently at a valid element else
      returns false 
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#ac8b8efc630a1ee6abe6ba2a153bf0047">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a686d52bcba67526bbc998165fe61f8e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a686d52bcba67526bbc998165fe61f8e1">&#9670;&nbsp;</a></span>fix_stack()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::fix_stack </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char&#160;</td>
          <td class="paramname"><em>depth</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - pops the top of the stack and returns it
</pre><p> ! </p>

</div>
</div>
<a id="a833d5f1767dabc21cb6da8fe635f53ec"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a833d5f1767dabc21cb6da8fe635f53ec">&#9670;&nbsp;</a></span>get_count()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::get_count </td>
          <td>(</td>
          <td class="paramtype">const domain &amp;&#160;</td>
          <td class="paramname"><em>item</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td>
          <td class="paramname"><em>tree_root</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t != 0 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - if (t-&gt;balance is &lt; 1 or &gt; 1) then 
        - keep_node_balanced() will ensure that #t-&gt;balance == 0, -1, or 1
    - #t is still a binary search tree
    - returns true if it made the tree one height shorter 
    - returns false if it didn't change the height
</pre><p> ! </p>

</div>
</div>
<a id="a55a09ae0307c71319e5952de10c0ab47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a55a09ae0307c71319e5952de10c0ab47">&#9670;&nbsp;</a></span>keep_node_balanced()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::keep_node_balanced </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (there is a domain element equivalent to d in t) then
        - returns a pointer to the element in the range equivalent to d
    - else
        - returns 0
</pre><p> ! </p>

</div>
</div>
<a id="a2f0697302d80d64b871d2851e0e1f7ab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2f0697302d80d64b871d2851e0e1f7ab">&#9670;&nbsp;</a></span>move_next()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::move_next </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element_valid() == true
ensures
    - returns a non-const reference to the current element
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a1b204b94acddc602ed8750731c7550ce">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a83ac44b65c7ca10e0f33b58685a65a09"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a83ac44b65c7ca10e0f33b58685a65a09">&#9670;&nbsp;</a></span>pop()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain, typename range, typename mem_manager, typename compare = std::less&lt;domain&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a>* <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::pop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - pushes n onto the stack
</pre><p> ! </p>

</div>
</div>
<a id="ad4778a513f7c9dfa94621bbe8250cfa5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad4778a513f7c9dfa94621bbe8250cfa5">&#9670;&nbsp;</a></span>push()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain, typename range, typename mem_manager, typename compare = std::less&lt;domain&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::push </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td>
          <td class="paramname"><em>n</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t != 0
ensures
    - deallocates the node pointed to by t and all of t's left and right children
</pre><p> ! </p>

</div>
</div>
<a id="a97284253c0e7b4c9e2b4a715e6497f74"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a97284253c0e7b4c9e2b4a715e6497f74">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1pair__remover.html#a07c56b5db740660bed160d3ed3e3770f">dlib::pair_remover&lt; domain, range &gt;</a>.</p>

</div>
</div>
<a id="a77eaa41d98b18d23f821c8efe3c943e0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a77eaa41d98b18d23f821c8efe3c943e0">&#9670;&nbsp;</a></span>remove_biggest_element_in_tree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::remove_biggest_element_in_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t-&gt;balance == 2 
    - t-&gt;right-&gt;balance == -1 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - #t is still a binary search tree 
    - #t now has a balance of 0 
    - #t now has a height smaller by 1
</pre><p> ! </p>

</div>
</div>
<a id="a15d9cab709e10e2e1ff726db254b1238"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15d9cab709e10e2e1ff726db254b1238">&#9670;&nbsp;</a></span>remove_current_element_from_tree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::remove_current_element_from_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>cur_stack_pos</em> = <code>1</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - current_element != 0
    - depth == 0
    - t == tree_root
ensures
    - makes the stack contain the correct set of parent pointers.
      also adjusts stack_pos so it is correct.
    - #t is still a binary search tree                                     
</pre><p> ! </p>

</div>
</div>
<a id="a2aaa57cc756c29b278da5177c0e19467"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2aaa57cc756c29b278da5177c0e19467">&#9670;&nbsp;</a></span>remove_from_tree() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::remove_from_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d_copy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t == reference to the pointer in t's parent node that points to t
ensures
    - the mapping (d --&gt; r) has been added to #t 
    - #d and #r have initial values for their types
    - #t is still a binary search tree 
    - returns false if the height of the tree has not changed 
    - returns true if the height of the tree has grown by one
</pre><p> ! </p>

</div>
</div>
<a id="ae337c557ee2655f08f140c551e0ba0be"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae337c557ee2655f08f140c551e0ba0be">&#9670;&nbsp;</a></span>remove_from_tree() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::remove_from_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const domain &amp;&#160;</td>
          <td class="paramname"><em>item</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - return_reference(t,d) != 0
    - t == reference to the pointer in t's parent node that points to t
ensures
    - #d_copy is equivalent to d                                    
    - an element in t equivalent to d has been removed and swapped 
      into #d_copy and its associated range object has been 
      swapped into #r
    - #t is still a binary search tree                                     
    - returns false if the height of the tree has not changed 
    - returns true if the height of the tree has shrunk by one
</pre><p> ! </p>

</div>
</div>
<a id="a615d634af52cb9a8431e42d3b8900c45"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a615d634af52cb9a8431e42d3b8900c45">&#9670;&nbsp;</a></span>remove_least_element_in_tree()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::remove_least_element_in_tree </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t != 0  (i.e. there must be something in the tree to remove) 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - the biggest node in t has been removed 
    - the biggest node domain element in t has been put into #d 
    - the biggest node range element in t has been put into #r
    - #t is still a binary search tree 
    - returns false if the height of the tree has not changed 
    - returns true if the height of the tree has shrunk by one
</pre><p> ! </p>

</div>
</div>
<a id="a50dc035a8ef7a68435d13056aa2eb050"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a50dc035a8ef7a68435d13056aa2eb050">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns true if *this represents one position before the first element
      in the container (this would also make the current element invalid) 
      else returns false                
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a2904ebf4bc18e60b5669509416827a3e">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<a id="a2891dc81fcc89aa3b639b770b012205f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2891dc81fcc89aa3b639b770b012205f">&#9670;&nbsp;</a></span>return_reference() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const range * <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::return_reference </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - return_reference(t,item) != 0
    - t == reference to the pointer in t's parent node that points to t
ensures
    - an element in t equivalent to item has been removed                      
    - #t is still a binary search tree                                     
    - returns false if the height of the tree has not changed 
    - returns true if the height of the tree has shrunk by one
</pre><p> ! </p>

</div>
</div>
<a id="adf495bcfa6815a018eb364366b71c032"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adf495bcfa6815a018eb364366b71c032">&#9670;&nbsp;</a></span>return_reference() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">range * <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::return_reference </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&#160;</td>
          <td class="paramname"><em>t</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (there is a domain element equivalent to d in t) then
        - returns a pointer to the element in the range equivalent to d
    - else
        - returns 0
</pre><p> ! </p>

</div>
</div>
<a id="aadf3f5652822a89427cf79ce3de8fd07"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aadf3f5652822a89427cf79ce3de8fd07">&#9670;&nbsp;</a></span>rotate_right()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::rotate_right </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1node.html">node</a> *&amp;&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t-&gt;balance == 2 
    - t-&gt;right-&gt;balance == 0 or 1 
    - t == reference to the pointer in t's parent node that points to t
ensures
    - #t is still a binary search tree 
    - #t-&gt;balance is between 1 and -1 
    - #t now has a height smaller by 1 if #t-&gt;balance == 0
</pre><p> ! </p>

</div>
</div>
<a id="ab1ea985c164591279a5d82b822dfdc3f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab1ea985c164591279a5d82b822dfdc3f">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range , typename mem_manager , typename compare &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - moves to the next element.  i.e. #element() will now 
      return the next element in the container 
    - the return value will be equal to #current_element_valid() 
    - #at_start() == false 

    - returns true if there is another element 
    - returns false if there are no more elements in the container
</pre><p> ! </p>

<p>Implements <a class="el" href="classdlib_1_1enumerable.html#a3181bdae2392e004881efe86bb2cd412">dlib::enumerable&lt; map_pair&lt; domain, range &gt; &gt;</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a39033b2632f7aace9b0db6ac934d72ed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a39033b2632f7aace9b0db6ac934d72ed">&#9670;&nbsp;</a></span>p</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain, typename range, typename mem_manager, typename compare = std::less&lt;domain&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1binary__search__tree__kernel__1_1_1mpair.html">mpair</a> <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html">dlib::binary_search_tree_kernel_1</a>&lt; domain, range, mem_manager, compare &gt;::p</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">mutable</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - t == tree_root
    - cur_stack_pos == 1
    - current_element != 0
ensures
    - removes the data in the node given by current_element and swaps it into 
      #d and #r.  
    - #t is still a binary search tree                                     
    - the enumerator is advances on to the next element but its stack is 
      potentially corrupted.  so you must call fix_stack(tree_root) to fix
      it.
    - returns false if the height of the tree has not changed 
    - returns true if the height of the tree has shrunk by one
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="binary__search__tree__kernel__1_8h_source.html">binary_search_tree_kernel_1.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
